<template>
  <div class="risk-graph" ref="graph" v-if="isShowGraph">
    <ObTooltip
            position="top"
            v-for="(item, index) in computedList"
            :key="index"
            :visible-arrow="false"
    >
      <div slot="content">
        <div align="center" v-html="getTooltipText(item)"/>
      </div>
      <div
              class="risk-graph__item"
              :class="itemClass(item)"
              :style="itemStyle(item)"
      />
    </ObTooltip>
  </div>
</template>

<script>
  import { formatNumber } from 'common-components/src/helpers/common'
  import ObTooltip from 'common-components/src/obComponents/obTooltip'

  export default {
    name: 'ObRiskGraph',
    components: {
      ObTooltip
    },
    props: {
      items: {
        type: Array,
        default: () => []
      },
      fieldName: {
        type: String,
        default: ''
      }
    },
    computed: {
      currentRange () {
        if (!this.computedList.length) return null

        let startValue = this.computedList[0].constraints.from
        let endValueObj = this.computedList[this.computedList.length - 1].constraints
        let endValue = endValueObj.to === Infinity ? endValueObj.from : endValueObj.to
        return [ startValue, endValue ]
      },
      currentRangeDiff () {
        return this.currentRange ? this.currentRange[1] - this.currentRange[0] : null
      },
      computedList () {
        let list = [...this.items].sort((a, b) => a.constraints.from - b.constraints.from)
                                  .filter((item, index) => {
                                    let { from, to } = item.constraints

                                    return (!index && to) || (from && to) || (index === this.items.length - 1 && from)
                                  })
        let result = []

        list.forEach((item, index) => {
          let nextItemStart = null
          let endValue = +item.constraints.to

          if (list[index + 1]) {
            nextItemStart = +list[index + 1].constraints.from
          }

          result.push({ ...item })

          if (nextItemStart && (nextItemStart - endValue) > 1) {
            result.push({
              color: 'DEFAULT',
              constraints: { from: endValue + 1, to: nextItemStart - 1 }
            })
          }
        })
        return result
      },
      isShowGraph () {
        return this.computedList.filter(item => item.constraints.from && item.constraints.to).length
      }
    },
    methods: {
      itemClass (item) {
        return `--${item.color || item.risk_color}`
      },
      itemStyle (item) {
        let isInfinity = item.constraints.to === Infinity
        let itemValue = item.constraints.to - item.constraints.from
        let value = isInfinity ? '10px' : `${itemValue / this.currentRangeDiff * 100}%`
        let left = `${((item.constraints.from - this.currentRange[0]) / this.currentRangeDiff) * 100}%`

        return {
          width: this.currentRangeDiff ? value : 'auto',
          left
        }
      },
      getTooltipText (item) {
        let isError = item.color === 'DEFAULT'
        let startValue = formatNumber(item.constraints.from)
        let endValue = item.constraints.to === Infinity ? '∞' : formatNumber(item.constraints.to)

        if (isError) {
          return `<div style="display: flex; color: red;"><i class="icon alert"/><span style="padding: 2px 5px;">Не заполнен интервал<br/>${startValue} - ${endValue}</span><div/>`
        }

        return `${this.fieldName}<br/>${startValue} - ${endValue} ₽`
      }
    }
  }
</script>

<style lang="scss">
  .risk-graph {
    position: relative;
    display: flex;
    justify-content: flex-start;
    align-items: center;
    width: calc(100% - 6px);
    height: 12px;
    margin-top: 10px;
    background-color: $organizationsCardConfiguratorPage-risk-graph_background-color;
    margin-bottom: 6px;
    &__item {
      position: absolute;
      top: 0;
      height: 12px;
      min-width: 10px;
      cursor: pointer;

      &::after {
        content: '';
        position: absolute;
        z-index: 100;
        top: 0;
        left: 100%;
        width: 0;
        height: 0;
        border-style: solid;
        border-width: 6px 0 6px 6px;
      }


      &.--DEFAULT {
        background: $color-grey-span;
        &::after {
          border-color: transparent transparent transparent $color-grey-span;
        }
      }

      &.--YELLOW {
        background: $gorse-yellow;
        box-shadow: 2px 2px 5px rgba($gorse-yellow, 0.4);

        &::after {
          border-color: transparent transparent transparent $gorse-yellow;
        }
      }

      &.--BLACK {
        background: $color-text-base;
        box-shadow: 2px 2px 5px rgba($color-text-base, 0.4);

        &::after {
          border-color: transparent transparent transparent $color-text-base;
        }
      }

      &.--RED {
        background: $color-error;
        box-shadow: 2px 2px 5px rgba($color-error, 0.4);

        &::after {
          border-color: transparent transparent transparent $color-error;
        }
      }

      &.--GREEN {
        background: $color-green-light;
        box-shadow: 2px 2px 5px rgba($color-green-light, 0.4);

        &::after {
          border-color: transparent transparent transparent $color-green-light;
        }
      }

      &.--BLUE {
        background: $organizationsCardConfiguratorPage-risk-graph_blue;
        box-shadow: 2px 2px 5px rgba($light-denim, 0.4);

        &::after {
          border-color: transparent transparent transparent $organizationsCardConfiguratorPage-risk-graph_blue;
        }
      }

      &.--ORANGE {
        background: $organizationsCardConfiguratorPage-risk-graph_orange;
        box-shadow: 2px 2px 5px rgba($diamond-orange-yellow, 0.4);

        &::after {
          border-color: transparent transparent transparent $organizationsCardConfiguratorPage-risk-graph_orange;
        }
      }
    }
  }
</style>
